# 1. kapitola Popisn statistiky
#
# pro jistotu vyistit pracovn prostor
rm(list=ls())
# datov soubor Stulong
data(Stulong)
names(Stulong)
table(Stulong$Skupina)
bmiZdrav <- with(Stulong,bmi[Skupina=="NS&NSS"])
length(bmiZdrav)
bmiNemocn <- with(Stulong,bmi[Skupina=="PS"])
length(bmiNemocn)
# vypi hodnoty bmiZdrav
bmiZdrav
#
# data o EU za rok 2010
#
data(EU2010)
summary(EU2010)
EU2010[,"zem"]
print(V4 <- EU2010[,"zem"] %in% c("CZ","HU","PL","SK"))
EU2010[V4,"zem"]     # kontrola
EU2010[V4,"HDP"]      # HDP zem V4
with(EU2010[V4,],HDP) # tot jinak
with(EU2010[V4,],mean(HDP))  #  prmr HDP
with(EU2010[V4,],weighted.mean(HDP,w=obyvatel))  #  ven prmr HDP
#
# pklad pjmy
#
plat <- c(17, 23, 69, 19, 32)
vazek <- c(1, 1, 1, 0.5, 0.5)
mean(plat)
print(pjem <- plat * vazek)
mean(pjem)
weighted.mean(plat,w=vazek)
#
# vypi uspodan hodnoty bmiZdrav
#
(bmiZdravSRT <- sort(bmiZdrav))
 min(bmiZdrav)
 max(bmiZdrav)
 mean(bmiZdrav)
 median(bmiZdrav)
#
quantile(bmiZdrav,probs=c(0,25,50,75,100)/100)
mean(bmiZdrav,trim=0.1)
mean(log(bmiZdrav))
mean(log(bmiZdrav),trim=0.1)
print(tab <- table(round(bmiNemocn,1)))
tab[tab==max(tab)]
#
# medin (BMI zdravch mu, nemocnch mu)
#
print(nZdrav <- length(bmiZdrav))
sort(bmiZdrav)[c(nZdrav/2,nZdrav/2+1)]
mean(sort(bmiZdrav)[c(nZdrav/2,nZdrav/2+1)])
median(bmiZdrav)
#
print(nNemocn <- length(bmiNemocn))
(nNemocn+1)/2
print(medin <- sort(bmiNemocn)[(nNemocn+1)/2])
median(bmiNemocn)
sum(bmiNemocn<medin)     #  kolik mench
sum(bmiNemocn>medin)     #  kolik vtch
#
# kvartily
#
# zdrav
print(k <- floor(1 + (nZdrav-1)*(1/4)))  # cel st
print(q <- 1 + (nZdrav-1)*(1/4)-k)       # zlomkov st
c(1 + (nZdrav-1)*(1/4),k+q)        # kontrola
print(Q1 <- (1-q)*sort(bmiZdrav)[k]+q*sort(bmiZdrav)[k+1])
weighted.mean(sort(bmiZdrav)[c(k,k+1)],w=c(1-q,q))
quantile(bmiZdrav,probs=1/4)
#
print(k <- floor(1 + (nZdrav-1)*(3/4)))  # cel st
print(q <- 1 + (nZdrav-1)*(3/4)-k)       # zlomkov st
c(1 + (nZdrav-1)*(3/4),k+q)        # kontrola
print(Q3 <- (1-q)*sort(bmiZdrav)[k]+q*sort(bmiZdrav)[k+1])
weighted.mean(sort(bmiZdrav)[c(k,k+1)],w=c(1-q,q))
quantile(bmiZdrav,probs=3/4)
#
quantile(bmiZdrav,probs=(1:3)/4)
#
# useknut prmr, alpha = 0,1
#
# nejprve, e je to ven prmr
print(vynech <- floor(0.1 * nZdrav))
print(vhy <- c(rep(0,vynech),rep(1,nZdrav-2*vynech),rep(0,vynech)))
weighted.mean(sort(bmiZdrav),vhy)
mean(bmiZdrav, trim=0.1)    #  tohle je snaz
# useknut prmr pro nemocn
mean(bmiNemocn)
mean(bmiNemocn,trim=0.1)
median(bmiNemocn)
mean(log(bmiNemocn))
mean(log(bmiNemocn),trim=0.1)
mean(log(bmiNemocn),trim=0.1)/mean(log(bmiNemocn))
mean(bmiNemocn,trim=0.1)/mean(bmiNemocn)
#
# modus u nemocnch
#
round(bmiNemocn,0)
print(tab <- table(round(bmiNemocn,0)))
which.max(tab)        # kde je maximln etnost
print(maximum <- max(tab))  # maximln etnost
print(tab <- table(round(bmiNemocn,1)))
which.max(tab)        # kde je PRVN maximln etnost
print(maximum <- max(tab))  # maximln etnost
tab == maximum        # kde jsou maximln etnosti
tab[tab == maximum]   # seznam maximlnch etnost
print(tab <- table(round(bmiNemocn,2)))
which.max(tab)        # kde je PRVN maximln etnost
print(maximum <- max(tab))  # maximln etnost
tab == maximum        # kde jsou maximln etnosti
tab[tab == maximum]   # seznam maximlnch etnost
#
#	uspodan hodnoty bmiZdrav
print(bmiZdravSRT <- sort(bmiZdrav))
#
# vechny kvartily BMI zdravch najednou
#
quantile(bmiZdrav,probs=c(0,25,50,75,100)/100)
#
# z-skr
#
print(x <- c(9,6,15,4,9,5))
mean(x)
sd(x)
print(z <- (x-mean(x))/sd(x))   # vpoet podle definice
scale(x)                  # snaz vpoet, ale vsledkem matice
c(scale(x))			  # nyn ji jen vektor
#	vlastnosti z-skr:
mean(z)
sd(z)
mean(z^3)                 # vbrov ikmost
mean(z^4)                 # vbrov piatost
#
#	mry variability
max(bmiZdrav)-min(bmiZdrav)
quantile(bmiZdrav,probs=3/4)-quantile(bmiZdrav,probs=1/4)
#	dal monosti (pro zvdavce):
sum(quantile(bmiZdrav,probs=c(3,1)/4)*c(1,-1))
crossprod(quantile(bmiZdrav,probs=c(3,1)/4),c(1,-1))
quantile(bmiZdrav,probs=c(3,1)/4)%*%c(1,-1)
#
sd(bmiZdrav)
var(bmiZdrav)
z <- scale(bmiZdrav)
mean(z)
var(z)
mean(z^3)	#	ikmost
mean(z^4)	#	piatost
# empirick distribun funkce
#
print(xx <- c(1, 3, 4, 5, 3))
# definice emp. distr. fce
edf <- function(x,data){ mean(data<=x) }
edf(1,xx)		#	hodnota pro x=1
edf(4.5,xx)		#	hodnota pro x=4,5
plot(ecdf(xx))
plot(ecdf(bmiNemocn),col="red")
plot(ecdf(bmiZdrav),add=TRUE)
legend("bottomright",legend=c("zdrav","nemocn"),col=c("black","red"),pch=19)
# porovnn dvou vbr
boxplot(bmiZdrav,bmiNemocn,names=c("zdrav","nemocn"))
# histogram
hist(bmiZdrav,xlab="zdrav",ylab="etnost")
#
# geografie
#
# obyvatel R
#
data(Kraje)
Kraje[1:3,]
attach(Kraje)
(kaObyv <- weighted.mean(ka,w=obyvatel))
(dlkaObyv <- weighted.mean(dlka,w=obyvatel))
(kaT <- weighted.mean(ka,w=rozloha))
(dlkaT <- weighted.mean(dlka,w=rozloha))
#
tab <- Kraje[order(dlka),c("dlka","obyvatel")]
rownames(tab) <- Kraje[order(dlka),"Zkratka"]
tab <- cbind(tab,"souet"=cumsum(tab[,"obyvatel"]),
    "podl" = cumsum(tab[,"obyvatel"])/sum(obyvatel))
tab
detach(Kraje)
#
# data o Evropsk unii
#
data(EU2010)            # nati data
names(EU2010)           # kter promnn?
V4 <- c(3,14,18,23)     # dky se zemmi V4
EU2010[V4,"zem"]       # zkratky nzv zem V4
rozdly <- with(EU2010[V4,],outer(lesy,lesy,"-"))
rownames(rozdly) <- colnames(rozdly) <- EU2010[V4,"zem"]
rozdly                 # vytiskni tabulku rozdl
mean(abs(rozdly))      # stedn diference
# Gini
with(EU2010[V4,],mean(abs(rozdly))/(2*mean(lesy)))
library(ineq)
with(EU2010[V4,],Gini(lesy))
# Lorenz
with(EU2010[V4,],sort(lesy))
with(EU2010[V4,],cumsum(sort(lesy)))
with(EU2010[V4,],cumsum(sort(lesy))/sum(lesy))
# grafick znzornn Lorenzovy kivky
with(EU2010[V4,],{      # zatek prce jen s V4
	n <- length(lesy)        # kolik zem
	xx <- (1:n)/n            # pravideln odstupy x-ovch souadnic
	yy <- cumsum(sort(lesy))/sum(lesy)
	plot(c(0,xx,0),c(0,yy,0),type="l",ylab="lesy",
	  xlab="stty",asp=1)
	polygon(c(0,xx,0),c(0,yy,0),col="grey")
	points(xx,yy,pch=3,cex=2)
	abline(h=c(0,1),v=c(0,1),lty="dotted")
	for (i in (1:(n-1))){
	  lines(rep(xx[i],2),c(0,yy[i]),lty="dotted")
	  lines(xx[i:(i+1)],rep(yy[i],2),lty="dotted")
	  }
	# popis Polska
	TXT <- zem[which.max(rozloha)]
	lines(x=rep(xx[n],2),y=yy[(n-1):n],lty=2)
	lines(x=xx[(n-1):n],y=rep(yy[n-1],2),lty=2)
	text(x=mean(xx[(n-1):n]),y=yy[n-1],label="1/4",pos=1)
	oldpar <- par(srt=90)
	text(x=1,y=0.85,label=paste("plocha (",TXT,")",sep=""),
	  pos=2)
	par(oldpar)
})
# vpoet plochy pod hlopkou a nad Lorenzovou kivkou
with(EU2010[V4,],{
	n <- length(lesy)          # poet cem V4
	yy <- cumsum(sort(lesy))/sum(lesy)
	obdlnky <- sum(0.25*yy[1:(n-1)])
	trojhelnky <- sum(0.5*0.25*diff(c(0,yy)))
	lut <- 0.5-(obdlnky+trojhelnky)
	Gini <- 2*lut
	print(Gini)
})
# dopotej zalesnn jako lesn plocha na km^2
EU2010 <- within(EU2010,zalesnn <- lesy*10/rozloha)
(EU2010[V4,c(1,2,8,17)])
# Lorenzova kivka s vahami
with(EU2010[V4,],{
	ord <- order(zalesnn)
	xx <- cumsum(rozloha[ord])/sum(rozloha)
	yy <- cumsum(lesy[ord])/sum(lesy)
	n <- length(zalesnn)
	plot(c(0,xx,0),c(0,yy,0),type="l",
	  ylab="lesy",xlab="stty",asp=1)
	polygon(c(0,xx,0),c(0,yy,0),col="grey")
	points(xx,yy,pch=3,cex=2)
	abline(h=c(0,1),v=c(0,1),lty="dotted")
	for (i in (1:(n-1))){
	  lines(rep(xx[i],2),c(0,yy[i]),lty="dotted")
	  lines(xx[i:(i+1)],rep(yy[i],2),lty="dotted")
	}
	# popis dvou seek:
	TXT <- zem[ord][2]
	lines(xx[1:2],rep(yy[1],2),lty=2)#,col="grey")
	lines(rep(xx[2],2),yy[1:2],lty=2)#,col="grey")
	text(x=mean(xx[1:2]),y=yy[1],
	  label=paste("rozloha (",TXT,")",sep=""),pos=1)
	oldpar <- par(srt=90)
	text(x=xx[2],y=mean(yy[1:2])+.15,
	  label=paste("plocha (",TXT,")",sep=""),
	  pos=2)
	par(oldpar)
})
#
# pm vpoet Giniho koeficeintu
with(EU2010[V4,],{
	ord <- order(zalesnn)
	xx <- cumsum(rozloha[ord])/sum(rozloha)
	yy <- cumsum(lesy[ord])/sum(lesy)
	zkladny <- diff(xx)
	vky <- yy[1:(length(yy)-1)]
	obdlnky <- sum(zkladny*vky)
	zkladny <- diff(c(0,xx))
	vky <- diff(c(0,yy))
	trojhelnky <- sum(0.5*zkladny*vky)
	lut <- 0.5-(obdlnky+trojhelnky)
	(Gini <- 2*lut)
})
# Giniho koeficient knihovn funkc
#
library(reldist)
with(EU2010[V4,],gini(zalesnn,weights = rozloha))
#
# lesn bohatstv zem V4
#
attach(EU2010[V4,])
ord <- order(zalesnn)     #  ur poad bod
k <- length(ord)
x <- c(0,rozloha[ord])      #  x-ov souadnice
y <- c(0,lesy[ord])         #  y-ov souadnice
X <- cumsum(x)              #  postupn souty x
Y <- cumsum(y)              #  postupn souty y
xBod <- X/X[k+1]            #  relativn postupn souty x
yBod <- Y/Y[k+1]            #  relativn postupn souty y
data.frame("zem"=c("",levels(zem)[zem[ord]]),
  x,y,X,Y,xBod,yBod)
detach(EU2010[V4,])
#
# porovnn Lorenzovy kivky pi rzn jemnm dlen
#
attach(Kraje)
permutace <- order(obyvatel/rozloha)
hustota <- (obyvatel/rozloha)[permutace]
x <- rozloha[permutace]; y = obyvatel[permutace]
X <- as.numeric(cumsum(x)); Y = as.numeric(cumsum(y))
# as.numeric(): abychom pracovali s relnmi, ne s celmi sly
tab <- cbind("obyv."=y,"rozloha"=x,"hustota"=hustota,
  "Xj"=X,"Yj"=Y)
rownames(tab) <- Zkratka[permutace]
tab
k <- length(x)
delta <- 2*(sum(X[-k]*Y[-1]-X[-1]*Y[-k])/X[k]^2)
print(paste("delta =",round(delta,3)))
prmr <- Y[k]/X[k]
print(paste("Gini =",round(delta/2/prmr,3)))
detach(Kraje)
#
# dvojice graf (kraje, okresy)
#
library(ineq)  # zaveden knihovny
par(mar=c(4,4,1,1)+0.1)
with(Kraje,plot(Lc(obyvatel/rozloha,rozloha),main="",
  xlab="rozloha",ylab="obyvatel"))
with(Kraje,plot(Lc(obyvatel/rozloha,rozloha),main="",
  xlab="rozloha",ylab="obyvatel",lty=3))
data(Okresy)
with(Okresy,lines(Lc(obyvatel/rozloha,rozloha)))
legend("topleft",legend=c("kraje","okresy"),lty=c(3,1))
#
# vpoet knihovn funkc
#
require(reldist)
with(Kraje,gini(obyvatel/rozloha,rozloha))
with(Okresy,gini(obyvatel/rozloha,rozloha))
#
#	vlastn funkce pro vpoet Ginnniho koeficientu
#
giniW <- function(yPrum,x=rep(1,length(yPrum))){
permutace <- order(yPrum); k <- length(yPrum)
yPrum <- yPrum[permutace]; x <- x[permutace]
Xrel <- cumsum(x)/sum(x); Yrel <- cumsum(x*yPrum)/sum(x*yPrum)
gini <- sum(Xrel[-k]*Yrel[-1]-Xrel[-1]*Yrel[-k])
return(gini=gini)
}
#
Gkraje <- with(Kraje,giniW(obyvatel/rozloha,rozloha))
Gokresy <- with(Okresy,giniW(obyvatel/rozloha,rozloha))
paste("kraje:  G =",round(Gkraje,3))
paste("okresy: G =",round(Gokresy,3))
#
#	Theilv index
#
pjem <- c(200,150,80,70,60,60,20,20,18,18,15,15,10,10)
library(ineq)
Theil(pjem)
#	pm vpoet
sum(pjem/mean(pjem)*log(pjem/mean(pjem)))/length(pjem)
#
Skupina <- factor(c(rep(1,2),rep(2,4),rep(3,8)),
      label=c("A","B","C"))
prmry <- tapply(pjem,Skupina,mean)
prmr <- mean(pjem)
ni <- table(Skupina)
n <- sum(ni)
index <- Theil(pjem)
indexy <- tapply(pjem,Skupina,Theil)
W <- sum((ni*prmry)/(n*prmr)*indexy)
B <- sum(ni*prmry/prmr*log(prmry/prmr))/n
c("T"=index,"TB+TW"=B+W,"TB"=B,"TW"=W,"TB/T"=B/index)
#
#	rozklad soutu tverc
#
sst <- sum((pjem-prmr)^2)
ssa <- sum(ni*(prmry-prmr)^2)
sse <- sum((pjem-prmry[Skupina])^2)
c("SSE"=sse,"SSA"=ssa,"SSE+SSA"=sse+ssa,"SST"=sst)
#
#	Theilv index s vahami
#
TheilW <- function(y,w=rep(1,length(y))){
      yPrum <- weighted.mean(y,w=w)
      sum(w*y/yPrum*log(y/yPrum))/sum(w)
}
#
data(Okresy)
# vlome do Okresy novou promnnou zalidnn
Okresy <- within(Okresy,zalidnn<-100*obyvatel/rozloha)
attach(Okresy)
Tokres <- TheilW(zalidnn,w=rozloha)
# informace o jednotlivch krajch:
rozlohaKraje <- tapply(rozloha,Kraj,sum)
zalidnnKraje <- 100*tapply(obyvatel,Kraj,sum)/rozlohaKraje
Tkraj <- TheilW(zalidnnKraje,rozlohaKraje)
# jet indexy pro jednotliv kraje
Tkraje <- rep(NA,length(rozlohaKraje))
for (i in 1:length(rozlohaKraje))
      Tkraje[i] <- with(Okresy[Kraj==levels(Kraj)[i],],
                    TheilW(zalidnn,rozloha))
# souhrn informac o krajch          
cbind(rozlohaKraje,zalidnnKraje,
        "poet okres"=table(Kraj),Tkraje)          
# prmrn index uvnit kraj
TW <- sum(rozlohaKraje*zalidnnKraje/
          sum(rozlohaKraje*zalidnnKraje)*Tkraje) 
# oven rozkladu:
c("T"=Tokres,"TB"=Tkraj,"TW"=TW,"TB+TW"=Tkraj+TW,
      "TB/T"=Tkraj/Tokres)
#
detach(Okresy)


