#	2. kapitola
rm(list=ls())
# pklad senzitivita
pD <- 0.1                # apriorn pravdpodobnost nemoci
pP_D <- 0.9              # senzitivita
pnP_nD <- 0.95           # specificita
# pravdpodobnost pozitivn reakce testu:
print(pP  <-  pP_D*pD+(1-pnP_nD)*(1-pD))
# aposteriorn pravdpodobnost nemoci pi pozitivnm testu:
(pD_P <- pP_D*pD/pP)
# aposteriorn pravdpodobnost zdravho pi negativnm testu:
(pnD_nP <- pnP_nD*(1-pD)/(1-pP))
#
# losovn osoby ve V4
#
data(EU2010)
V4 <- with(EU2010,which(zem %in% c("CZ","HU","PL","SK")))
(apri <- with(EU2010[V4,],obyvatel/sum(obyvatel)))
(podm <- with(EU2010[V4,],vk65_))
(apost <- podm*apri/sum(podm*apri))
tab <- round(cbind(100*apri,podm,100*apost),1)
rownames(tab) <- EU2010[V4,"zem"]
colnames(tab) <- c("P(Hj) %","P(B|Hj) %","P(Hj|B) %")
tab
#
#	pklad poet dt
#
dt <- 1:4
podl <- c(45,38,12,5)/100
sum(dt*podl*100000)/100000
weighted.mean(dt,w=podl)
#
# pklad ponoky, X = poet edivch ponoek
#
(x <- 0:2)           # mon hodnoty nhodn veliiny X
(pX <- c(6, 8, 1)/15) # pravdpodobnosti monch hodnot
# stedn hodnota X:
(muX <- weighted.mean(x,w=pX))  
# rozptyl X
(sigma2X <- weighted.mean((x-muX)^2,w=pX))
(sigmaX <- sqrt(sigma2X))    # smrodatn odchylka
# sdruen rozdlen (X, Y):
y <- 0:2
# sdruen pravdpodobnosti:
pXY <- matrix(c(1,4,1,4,4,0,1,0,0),nrow=3,ncol=3)/15
rownames(pXY) <- paste("X =",x); colnames(pXY) <- paste("Y =",y)
round(pXY,3)
# marginln pravdpodobnosti:
cbind(pX,"marginln"=apply(pXY,1,sum))  # oven 
(pY <- apply(pXY,2,sum))    # 
(muY <- weighted.mean(y,w=pY))
(sigmaY <- sqrt(weighted.mean((y-muY)^2,pY)))
(covXY <- sum(outer(x-muX,y-muY,"*")*pXY))
(rhoXY <- covXY/(sigmaX*sigmaY))
#
# pravdpodobnosti binomickho rozdlen
#
k <- 0:12
tab <- cbind(k,dbinom(k,12,1/6),pbinom(k,12,1/6))
colnames(tab) <- c("k","P(Y=k)","P(Y<=k)")
prmatrix(round(tab,6),rowlab=rep("",nrow(tab)))
#
# pklad pohlav novorozenc
#
sum(dbinom(0:4,11,0.51)) # Jindra
sum(dbinom(7:8,11,0.51)) # Zdenk
# 
# pklad hrac kostka
#
cetnosti <- matrix(
  c(7,7,3,0,11,2,
    1,9,9,0,2,9,
    4,5,6,6,5,4,
    5,5,5,5,5,5),nrow=4,ncol=6,byrow=TRUE)
nn <- apply(cetnosti,1,sum)
if (var(nn)>0) stop("Poty pokus nejsou stejn!")
colnames(cetnosti) <- c("n1","n2","n3","n4","n5","n6")
psti <- rep(NA,nrow(cetnosti))
for (i in 1:length(psti))
      psti[i] <- dmultinom(cetnosti[i,],prob=rep(1,6)/6)
prmatrix(cbind(cetnosti,pst=round(psti,9)),rowlab=rep("",nrow(tab)))
#
# kombinan slo  35 nad 5
#
choose(35,5)
#
# pklad kopnut konm
#
data(HorseKicks,package="vcd")
print(HorseKicks)
(x <- as.numeric(names(HorseKicks)))
(lambdaHat <- weighted.mean(x,w=HorseKicks))
dpois(1,lambdaHat)
#
# pklad mlad hri volejbalu
#
1-pnorm((148.5-141.5)/7)
1-pnorm(148.5,mean=141.5,sd=7)
pnorm(148.5,mean=141.5,sd=7,lower.tail=FALSE)
#
# pklad hrac kostka
#
pbinom(18,size=100,prob=1/6)
pnorm(18,mean=100/6,sd=sqrt(100*5/36))
pnorm(18.5,mean=100/6,sd=sqrt(100*5/36))
#
# pklad vk matek 
#
# ji nasimulovan prmry:
data(simulaceTisic)
hist(x,xlim=range(x),main="populace",xlab="")
# doporuuji nastavit ukldn graf a vloit tam posledn graf
# stl mtko:
hist(x1,xlim=range(x),main="n=1",xlab="")
hist(x10,xlim=range(x),main="n=10",xlab="")
hist(x100,xlim=range(x),main="n=100",xlab="")
# pizpsobit mtko datm
hist(x,main="populace",xlab="")
hist(x1,main="n=1",xlab="")
hist(x10,main="n=10",xlab="")
hist(x100,main="n=100",xlab="")
#
