# 5. kapitola    Dva vbry
#
rm(list=ls())
#
# pklad vky dt
set.seed(17)                       #  nastaven genertoru
(hoi <- round(rnorm(9,138,7),0))  #  simulace vek hoch
(dvky <- round(rnorm(9,140,7),0)) #  simulace vek dvek
#
boxplot(hoi,dvky,ylab="vka",names=c("hoi","dvky"),col="yellow")
shapiro.test(hoi)                 #  test normality
shapiro.test(dvky)
#    klasick dvouvbrov t-test
t.test(hoi,dvky,var.equal=TRUE)
#    test shody populanch rozptyl
var.test(hoi,dvky)
#    Welchv t-test nepedpokldajc shodu populanch rozptyl
t.test(hoi,dvky)
#
# pklad cholesterol
#
data(Stulong)
normln <- with(Stulong,chlst[vk==43&Skupina=="NS&NSS"])
rizikov <- with(Stulong,chlst[vk==43&(Skupina=="RSI"|Skupina=="RSK")])
boxplot(normln,rizikov,ylab="cholesterol",
    names=c("normln","rizikov"),col="grey")
t.test(normln,rizikov)
var.test(normln,rizikov)
shapiro.test(normln)
shapiro.test(rizikov)
#
# pklad kostky cukru
#
data(Stulong)
normln <- with(Stulong,cukr[vk==43&Skupina=="NS&NSS"])
rizikov <- with(Stulong,cukr[vk==43&(Skupina=="RSI"|Skupina=="RSK")])
boxplot(normln,rizikov,ylab="kostek cukru",
    names=c("normln","rizikov"),col="grey")
median(normln)
median(rizikov)
shapiro.test(normln)
shapiro.test(rizikov)
wilcox.test(normln,rizikov)
#
# podrobn vpoet testu
#
tt <- table(c(normln,rizikov), rep(c("normln","rizikov"),
        c(length(normln),length(rizikov))))
ttt <- cbind(as.integer(rownames(tt)),addmargins(tt,2))
colnames(ttt) <- c("kostek","norm.","rizik.","celkem")
tab <- cbind(ttt,"poad"=cumsum(ttt[,"celkem"])-(ttt[,"celkem"]-1)/2)
tab <- cbind(tab,"R(norm.)"=tab[,"norm."]*tab[,"poad"],
      "R(rizik.)"=tab[,"rizik."]*tab[,"poad"])
rownames(tab) <- rep(" ",nrow(tab))
celkem <- apply(tab,2,sum)
celkem[c("kostek","poad")] <- NA
tab <- rbind(tab,celkem)
print(tab,na.print="")
# oven vztahu Mannova-Whitneyova a Wilcoxonova testu
dif <- outer(normln, rizikov,"-")  #  rozdly ve dvojicch
dif[1:4,1:4]              # ukzka tabulky rozdl
sum(dif>0)+sum(dif==0)/2  # statistika Manna-Whitneye
#
# pklad vno
#
# kontingenn tabulka:
addmargins(tab<-xtabs(~Skupina+Vno,data=Stulong,
  subset=Skupina%in%c("RSK","RSI"),drop.unused.levels=TRUE))
#
prop.table(tab,1)
#  testy
prop.test(tab)
prop.test(tab,correct=FALSE)
#
