# 6. kapitola  Analza rozptylu
#
rm(list=ls())
#
# pklad cholesterol
#
data(Stulong)
# vyber jen mue 50let
Stulong50 <- Stulong[Stulong$vk==50,]
class(Stulong50$chlst)
class(Stulong50$Skupina)
#
plot(chlst~Skupina,data=Stulong50,ylab="cholesterol",col="grey")
#
tab <- with(Stulong50,
      rbind(tapply(chlst,Skupina,function(x) sum(!is.na(x))),
            tapply(chlst,Skupina,mean),
            tapply(chlst,Skupina,sd)))
rownames(tab) = c("poet hodnot","prmr","smr. odch.")
tab
#
#	obr. 6.2
#
plot(chlst~as.numeric(Skupina),data=Stulong50,
    xlab="",ylab="cholesterol",pch=3,xaxt="n")
with(Stulong,axis(1,at=1:nlevels(Skupina),labels=levels(Skupina)))
prumery = with(Stulong50,tapply(chlst,Skupina,mean))
prumer = with(Stulong50,mean(chlst))
points(1:4,prumery,pch=16,cex=2)
abline(h=prumer,lty=3)
#
# jednoduch tdn, cholesterol
#
oneway.test(chlst~Skupina,data=Stulong50,var.equal=TRUE)
oneway.test(chlst~Skupina,data=Stulong50,var.equal=FALSE)
#  bn tabulka analzy rozptylu
anova(lm(chlst~Skupina,data=Stulong50))
#  tabulka analzy rozptylu doplnn o celkovou variabilitu
rbind(anova(lm(chlst~Skupina,data=Stulong50)),
    "total"=anova(lm(chlst~1,data=Stulong50)))
#  test homoskedasticity
bartlett.test(chlst~Skupina,data=Stulong50)
library(car)
leveneTest(lm(chlst~Skupina,data=Stulong50))
#  mnohonsobn porovnn
a <- aov(chlst~Skupina,data=Stulong50)
TukeyHSD(a)
par(mar=c(2,7,2,1)+0.1)	#	aby se veel popis osy y
plot(TukeyHSD(a),las=1)	#	las=1 aby popis osy y vodorovn
#
# Kruskalv-Wallisv test
#
kruskal.test(bmi~Skupina,data=Stulong50)
#
# dvojn tdn, systolick tlak
#
tab <- with(Stulong50,rbind(
    tapply(syst1,Skupina,length),
    tapply(syst1,Skupina,mean),
    tapply(syst1,Skupina,sd),
    tapply(syst1,Skupina,function(x) shapiro.test(x)$p.value),
    tapply(rank(syst1),Skupina,mean)))
rownames(tab) = c("poet hodnot","prmr","smr. odch.",
    "p-hodnota testu normality","prm. poad")
round(tab,3)
#
#	pklad Howells 
#
data(Howells)
with(Howells,tapply(gol,list(Gender,Popul),mean))
with(Howells,tapply(gol,list(Gender,Popul),sd))
with(Howells,interaction.plot(Popul,Gender,gol))
with(Howells,tapply(oca,list(Gender,Popul),mean))
with(Howells,tapply(oca,list(Gender,Popul),sd))
with(Howells,interaction.plot(Popul,Gender,oca))
#
summary(aGOL <- aov(gol~Gender*Popul,data=Howells))
TukeyHSD(aGOL,which="Popul")
#
summary(aOCA <- aov(oca~Gender*Popul,data=Howells))
summary(aOCA_AB <- aov(oca~Gender:Popul,data=Howells))
TukeyHSD(aOCA_AB)
par(mar=c(2,10,2,1)+0.1)
plot(TukeyHSD(aOCA_AB),las=1)
#
# pklad transpirace
#
data(Transpirace)
source("TukeyTest.R")
tab = with(Transpirace,matrix(trans,nrow=nlevels(Doba),ncol=nlevels(Rostlina)))
rownames(tab) <- with(Transpirace,levels(Doba))
colnames(tab) <- with(Transpirace,levels(Rostlina))
round(t(tab),2)	#	funkce t() transponuje (oto) matici transpirac
with(Transpirace,TukeyTest(trans,Rostlina,Doba))
with(Transpirace,TukeyTest(log(trans),Rostlina,Doba))
#
# nhodn bloky
#
# pklad transpirace
#
summary(aov(log(trans)~Error(Rostlina)+Doba,data=Transpirace))
summary(aov(log(trans)~Rostlina+Doba,data=Transpirace))
#
# Friedmanv test
#
# pklad myi
#
data(Mysi)
tab <- with(Mysi,matrix(prirustek,nrow=nlevels(Vrh),ncol=nlevels(Dieta)))
tab <- rbind(tab,apply(tab,2,mean))
tab <- cbind(tab,apply(tab,1,mean))
rownames(tab) <- c(paste(1:nlevels(Mysi$Vrh),". vrh",sep=""),"prmr")
colnames(tab) <- c(paste("dieta",c("A","B","C","D")),"prmr")
tab
#  Friedmanv test
friedman.test(prirustek~Dieta|Vrh,data=Mysi)
#  Kruskalv-Wallisv test neprvem pouit:
kruskal.test(prirustek~Dieta,data=Mysi)
