# 7. kapitola Korelace a regrese
#
rm(list=ls())
#
#  pklad Galton
#
data(GaltonSyn)
plot(syn~otec,data=GaltonSyn,pch=3)
abline(lm(syn~otec,data=GaltonSyn))
b <- coef(lm(syn~otec,data=GaltonSyn))
c <- coef(lm(otec~syn,data=GaltonSyn))
abline(-c[1]/c[2],1/c[2],lty=2)
#
cor.test(~syn+otec,data=GaltonSyn)
#
# pklad emise CO_2
#
data(EU2010)
plot(emiseCO2~HDP,data=EU2010,pch=3)
text(65000,20,label="Lucembursko",pos=2)
#
cor.test(~HDP+emiseCO2,method="spearman",data=EU2010)
indexLU <- with(EU2010,which(zem=="LU"))
cor.test(~HDP+emiseCO2,method="spearman",data=EU2010,subset=-indexLU)
#
cor.test(~HDP+emiseCO2,method="spearman",data=EU2010)
cor.test(~HDP+emiseCO2,method="spearman",data=EU2010,subset=-indexLU)
cor.test(~HDP+emiseCO2,method="pearson",data=EU2010)
cor.test(~HDP+emiseCO2,method="pearson",data=EU2010,subset=-indexLU)
# oven souvislosti Spearmanova a Pearsonova rorelanho koeficientu
with(EU2010,cor(HDP,emiseCO2,method="spearman"))
with(EU2010,cor(rank(HDP),rank(emiseCO2),method="pearson"))
#
# regresn pmka
#
# pklad Galton
#
summary(a <- lm(syn~otec,data=GaltonSyn))
anova(a)
#	zvislost syn ~ otec:
summary(lm(otec~syn,data=GaltonSyn))
#	souvislost smrnic a koeficientu determinace:
c(c[2]*b[2],summary(a)$r.squared)
#
# pklad emise CO_2
#
aCO2 <- lm(emiseCO2~HDP,data=EU2010,subset=zem!="LU")
summary(aCO2)
round(confint(aCO2),6)
#
source("kresliCtverce.R")
with(EU2010,ctverce(HDP[-indexLU],emiseCO2[-indexLU],ltySq=1,
  colSq="grey",xNAME="HDP",yNAME="emiseCO2"))
#
aCO2Lu <- lm(emiseCO2~HDP,data=EU2010)
plot(emiseCO2~HDP,data=EU2010,pch=3)
with(EU2010,points(mean(HDP),mean(emiseCO2),pch=20,cex=2))
with(EU2010[-indexLU,],points(mean(HDP),mean(emiseCO2),pch=17,cex=2))
abline(aCO2Lu)
abline(aCO2,lty=2)
legend("bottomright",legend=c("bez Luxemburska","vetn Luxemburska"),
    lty=c(2,1),pch=c(17,20))
#
summary(lm(emiseCO2~HDP,data=EU2010)) # vetn Lux.
summary(aCO2)                         # bez Lux
#
# pklad tuk
#
data(Policie)
# zvislost procenta tuku na vce
plot(fat~height,data=Policie,pch=3)
abline(lm(fat~height,data=Policie))
# zvislost procenta tuku na vze
plot(fat~weight,data=Policie,pch=3)
abline(lm(fat~weight,data=Policie))
# zvislost procenta tuku na vce
aH <- lm(fat~height,data=Policie)
summary(aH)
# zvislost procenta tuku na vce a vze
aHW <- lm(fat~height+weight,data=Policie)
summary(aHW)
#  beta koeficienty
attach(Policie)
summary(lm(scale(fat)~scale(height)+scale(weight)))
detach(Policie)
# regresn diagnostika
#	POZOR, bude teba klepnout do grafu!
plot(aHW)
# testy normality
shapiro.test(rstandard(aHW))
shapiro.test(residuals(aHW))
# testy homoskedasticity
library(lmtest)
bptest(aHW,varformula=~fitted(aHW))
bptest(aHW)
bptest(aHW,varformula=~height,data=Policie)
bptest(aHW,varformula=~weight,data=Policie)
bptest(aHW,varformula=~pulse,data=Policie)
#
# transformace
#
# pklad odpad
#
summary(aOdpad <- lm(odpad~HDP,data=EU2010))
summary(aOdpadLog <- lm(log(odpad)~log(HDP),data=EU2010))
# pprava vykreslen kivky:
hdp = with(EU2010,seq(min(HDP),max(HDP),length=101))
nd = data.frame(HDP=hdp)
#  graf v pvodnm mtku
plot(odpad~HDP,data=EU2010,pch=4)
abline(aOdpad,lty=2)
lines(hdp,exp(predict(aOdpadLog,newdata=nd)))#,lty=3)
legend("bottomright",legend=c("log(odpad)","odpad"),
    lty=c(1,2))
#  graf v logaritmickm mtku
plot(log(odpad)~log(HDP),data=EU2010,pch=4)
abline(aOdpadLog)
#
